/* Handy definitions */

#define FALSE	0
#define TRUE	1

/* Some definitions to cope with multiple platforms. __EMX__ means OS/2
 * which obviously isn't unix.  However, for the purposes of this program,
 * it's close enough from the point of view of compiler syntax to be tarred
 * with the same brush.
 */

#if defined(__linux__) || defined (__FreeBSD__) || defined(__EMX__)
# define MPRIME_i386_UNIX
#endif

/* This controls whether we want to pause computation if the load average */
/* becomes too great.  This does not apply to OS/2. */

#if defined(__linux__) || defined (__FreeBSD__)
# define MPRIME_LOADAVG
#endif

/* Handle the difference between the naming conventions in the two */
/* C compilers.  We only need to to this for global variables that */
/* referenced by the assembly routines */

#define ERRCHK	 _ERRCHK
#define CPU_TYPE _CPU_TYPE
#define SUMOUT	 _SUMOUT
#define SUMINP	 _SUMINP
#define MAXERR	 _MAXERR
#define PARG	 _PARG
#define FACLSW	 _FACLSW
#define FACMSW	 _FACMSW
#define FACPASS	 _FACPASS

#define FFTLEN	_FFTLEN
#define SRCARG	_SRCARG
#define SRC2ARG	_SRC2ARG
#define DESTARG	_DESTARG
#define U	_U
#define V	_V
#define Ulen	_Ulen
#define Vlen	_Vlen
#define EGCD_A	_EGCD_A
#define EGCD_B	_EGCD_B
#define EGCD_C	_EGCD_C
#define EGCD_D	_EGCD_D
#define EGCD_ODD _EGCD_ODD
#define NORM_ARRAY _NORM_ARRAY
#define RES	_RES
#define CARRYL	_CARRYL
#define CARRYH	_CARRYH
#define PLUS1	_PLUS1

/* Handle the difference in the way the two C compilers name routines */

#define setup80	 _setup80
#define setup96	 _setup96
#define setup112 _setup112
#define setup128 _setup128
#define setup160 _setup160
#define setup192 _setup192
#define setup224 _setup224
#define setup256 _setup256
#define setup320 _setup320
#define setup384 _setup384
#define setup448 _setup448
#define setup512 _setup512
#define setup640 _setup640
#define setup768 _setup768
#define setup896 _setup896
#define setup1024 _setup1024
#define lucas80	 _lucas80
#define lucas96	 _lucas96
#define lucas112 _lucas112
#define lucas128 _lucas128
#define lucas160 _lucas160
#define lucas192 _lucas192
#define lucas224 _lucas224
#define lucas256 _lucas256
#define lucas320 _lucas320
#define lucas384 _lucas384
#define lucas448 _lucas448
#define lucas512 _lucas512
#define lucas640 _lucas640
#define lucas768 _lucas768
#define lucas896 _lucas896
#define lucas1024 _lucas1024
#define setupf	 _setupf
#define factor64 _factor64

#define gw_setup _gw_setup
#define gw_add	_gw_add
#define gw_addq	_gw_addq
#define gw_sub	_gw_sub
#define gw_subq	_gw_subq
#define gw_copy	_gw_copy
#define gw_fft	_gw_fft
#define gw_mul	_gw_mul
#define gw_square _gw_square
#define gw_mulf	_gw_mulf
#define egetval _egetval
#define egcdhlp _egcdhlp
#define eaddhlp	_eaddhlp
#define emuladdhlp _emuladdhlp
#define emulsubhlp _emulsubhlp

/* Handle differences between Windows and Linux runtime libraries */

#define stricmp(x,y)	strcasecmp(x,y)
#define _commit(f)	fsync(f)
#define _open		open
#define _close		close
#define _read		read
#define _write		write
#define _lseek		lseek
#define _unlink		unlink
#define _creat		creat
#define _chdir		chdir
#define IsCharAlphaNumeric(c) isalnum(c)
#define _O_APPEND	O_APPEND
#define _O_RDONLY	O_RDONLY
#define _O_WRONLY	O_WRONLY
#define _O_RDWR		O_RDWR
#define _O_CREAT	O_CREAT
#define _O_TRUNC	O_TRUNC
#define _O_BINARY 	0
#define _O_TEXT		0

/* The common include files */

#include <time.h>
/*#define SERVER_TESTING*/
#define EXTERNC
extern int NO_GUI;
#include "commona.h"
#include "commonb.h"
#include "commonc.h"
#include "primenet.h"

/* Definitions */

#define DATA_ADDR	0x20010000	/* Addr of the input doubles */

/* Global variables */

extern int volatile THREAD_STOP;	/* TRUE if thread should stop */
extern int volatile THREAD_KILL;	/* TRUE if program should terminate */
extern int MENUING;			/* TRUE when main menu active */
extern int (*PRIMENET)(short, void *);

/* Internal routines */

void main_menu ();
int loadfac ();
int loadRightExe (unsigned long, unsigned long *);
void lucasSetup (unsigned long, unsigned long);

void setupf ();
int factor64 ();
void setup80 ();
void lucas80 ();
void setup96 ();
void lucas96 ();
void setup112 ();
void lucas112 ();
void setup128 ();
void lucas128 ();
void setup160 ();
void lucas160 ();
void setup192 ();
void lucas192 ();
void setup224 ();
void lucas224 ();
void setup256 ();
void lucas256 ();
void setup320 ();
void lucas320 ();
void setup384 ();
void lucas384 ();
void setup448 ();
void lucas448 ();
void setup512 ();
void lucas512 ();
void setup640 ();
void lucas640 ();
void setup768 ();
void lucas768 ();
void setup896 ();
void lucas896 ();
void setup1024 ();
void lucas1024 ();

