//
// Copyright 1995-1997 - Just For Fun Software, Inc., all rights reserved
// Author:  George Woltman
// Email: woltman@magicnet.net
//

#include "prime.h"
#include <ctype.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <math.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PORT	0
#define WIN_31_
#include "..\commona.c"
#include "..\commonb.c"
#include "..\commonc.c"

void SetPriority ()
{
}

void Sleep (unsigned long n)
{
	unsigned long	t;
	t = GetTickCount ();
	while (GetTickCount () < t + n) Yield ();
}

int FAR PASCAL loadfac ()		// Load the factoring program
{
	THE_END = 0x00100000;		// 1MB should be plenty
	if (! reserveMem ()) return (FALSE);
	return (load32 ("factor.dll"));
}

int FAR PASCAL loadRightExe (
	unsigned long p,
	unsigned long FAR *fftlen)
{
	char	buf[20];

// Find the best fft length.

	if (*fftlen == 0) {
		*fftlen = pick_fft_length (p);
	}

// The fft length determines the addresses.

	if (*fftlen == 1048576) THE_END = THE_END_1024;
	if (*fftlen == 917504) THE_END = THE_END_896;
	if (*fftlen == 786432) THE_END = THE_END_768;
	if (*fftlen == 655360) THE_END = THE_END_640;
	if (*fftlen == 524288) THE_END = THE_END_512;
	if (*fftlen == 458752) THE_END = THE_END_448;
	if (*fftlen == 393216) THE_END = THE_END_384;
	if (*fftlen == 327680) THE_END = THE_END_320;
	if (*fftlen == 262144) THE_END = THE_END_256;
	if (*fftlen == 229376) THE_END = THE_END_224;
	if (*fftlen == 196608) THE_END = THE_END_192;
	if (*fftlen == 163840) THE_END = THE_END_160;
	if (*fftlen == 131072) THE_END = THE_END_128;
	if (*fftlen == 114688) THE_END = THE_END_112;
	if (*fftlen == 98304) THE_END = THE_END_96;
	if (*fftlen == 81920) THE_END = THE_END_80;
	lucas = lucas_relay;

// Now we know how much memory to reserve

	if (! reserveMem ()) return (FALSE);

// Generate executable name and open it

	if (*fftlen == 1048576) strcpy (buf, "lucast24.dll");
	else sprintf (buf, "lucas%ld.dll", *fftlen / 1024);
	if (! load32 (buf)) return (FALSE);

// All done

	return (TRUE);
}

void FAR PASCAL lucasSetup (
	unsigned long p,
	unsigned long fftlen)
{

// Copy p to FACLSW, call setup

	FACLSW = p;
	setup32 ();
}

int FAR PASCAL load32 (
	LPSTR	filename)
{
	DWORD	load_offset = 0;
	char	errmsg[80];
	HFILE	hand;
	WORD	temp;
	LPSTR	buf;

/* Open EXE file to load */

	hand = _lopen (filename, READ);
	if (hand <= 0) goto err;

/* Skip trash at front of an EXE */

	_llseek (hand, 512L, 0);

/* Read 8K chunks into 32-bit address space */

	for ( ; ; load_offset += 8192) {
		if (Global16PointerAlloc (DataSel, load_offset, (LPDWORD) &buf,
					  8192, 0)) goto err;
		temp = _lread (hand, buf, 8192);
		if (Global16PointerFree (DataSel, (DWORD) buf, 0))
			goto err;
		if (temp != 8192) break;
	}

/* Close the EXE */

	_lclose (hand);
	return (TRUE);

// An error reading the file

err:	sprintf (errmsg, "FATAL ERROR: Unable to load %s\n", filename);
	OutputStr (errmsg);
	return (FALSE);
}


// An error?  How can that be?

void FAR PASCAL disaster ()
{
	writeResults ("Catastrophic memory error\n");
	_exit (1);
}

// Each FFT word is multiplied by a two-to-phi value.  These
// routines set and get the FFT value without the two-to-phi
// multiplier.

void get_fft_value (
	unsigned long p,
	unsigned long fftlen,
	unsigned long i,
	long	FAR *retval)
{
	double	FAR *dblp, tmp, pow;
	unsigned long b, s;

// Get address of fft value

	if (Global16PointerAlloc (DataSel, addr (p, fftlen, i),
				  (LPDWORD) &dblp, 8, 0))
		disaster ();

// The first FFT word is not multiplied by anything.

	if (i == 0) {
		*retval = (long) *dblp;
	}

// Compute the number of big FFT words.

	else {
		b = p % fftlen;

// Compute the number of small FFT words.

		s = fftlen - b;

// Divide by two-to-phi to generate an integer.
// Do not trust the pow routine.  The assembly code will
// generate the value with greater accuracy.

		tmp = *dblp;
		pow = (double) mulmod (s, i, fftlen) / (double) fftlen;
		__asm fld tmp
		__asm fld pow
		__asm f2xm1
		__asm fld1
		__asm faddp st(1), st
		__asm fdivp st(1), st
		__asm frndint
		__asm fstp tmp
		*retval = (long) tmp;
	}

// Exit

	if (Global16PointerFree (DataSel, (DWORD) dblp, 0)) disaster ();
}

void set_fft_value (
	unsigned long p,
	unsigned long fftlen,
	unsigned long i,
	long	val)
{
	double	FAR *dblp, tmp, pow;
	unsigned long b, s;

// Get address of fft value

	if (Global16PointerAlloc (DataSel, addr (p, fftlen, i),
				  (LPDWORD) &dblp, 8, 0))
		disaster ();

// The first FFT word is not multiplied by anything.

	if (i == 0) {
		*dblp = val;
	}

// Compute the number of big FFT words.

	else {
		b = p % fftlen;

// Compute the number of small FFT words.

		s = fftlen - b;

// Multiply value by two-to-phi before setting fft value.
// Do not trust the pow routine.  The assembly code will
// generate the value with greater accuracy.

		pow = (double) mulmod (s, i, fftlen) / (double) fftlen;
		__asm fld pow
		__asm f2xm1
		__asm fld1
		__asm faddp st(1), st
		__asm fimul val
		__asm fstp tmp
		*dblp = tmp;
	}

// Exit

	if (Global16PointerFree (DataSel, (DWORD) dblp, 0)) disaster ();
}


/* Load the PrimeNet DLL, make sure an internet connection is active */

int LoadPrimeNet ()
{

/* Load the DLL if necessary */

	OutputStr ("Unable to load PRIMENET.DLL.\n");
	return (FALSE);
}

void guessCpuType ()
{
	CPU_TYPE = 5;
	CPU_SPEED = 100;
}

int ecm (
	unsigned long p,		/* Mersenne exponent */
	unsigned long B,		/* Pass 1 bound */
	unsigned long C,		/* Pass 2 bound */
	unsigned long curves_to_do,	/* Number of curves to test */
	unsigned long curves_completed,	/* Number of curves already done */
	double	specific_curve)		/* Debug only - curve to test */
{
	OutputStr ("ECM not implemented\n");
	return (FALSE);
}

void doMiscTasks ()
{
}

void title (char *str)
{
}

void flashWindowAndBeep ()
{
	MessageBeep ((UINT) -1L);
	FlashWindow (hMainWnd, TRUE);
}

void lucas_relay ()
{
	lucas32 ();
}
